package edu.sc.seis.cormorant.plottable;

import java.util.Properties;
import org.omg.CORBA.ORB;
import org.omg.PortableServer.Servant;
import edu.sc.seis.cormorant.DBProvidingAbstractController;
import edu.sc.seis.cormorant.Start;
import edu.sc.seis.fissuresUtil.cache.BulletproofVestFactory;

/**
 * @author groves Created on Dec 10, 2004
 */
public class PlottableController extends DBProvidingAbstractController {

    public PlottableController(Properties confProps,
                               String serverPropName,
                               ORB orb) throws Exception {
        super(confProps, serverPropName, orb);
        boolean cacheOnly = Boolean.valueOf(confProps.getProperty(Start.CORMORANT_SERVERS
                                                                          + '.'
                                                                          + serverPropName
                                                                          + ".cacheOnly",
                                                                  "false"))
                .booleanValue();
        String dcDNS = confProps.getProperty(Start.CORMORANT_SERVERS + '.'
                + serverPropName + ".dataCenter.dns");
        String dcName = confProps.getProperty(Start.CORMORANT_SERVERS + '.'
                + serverPropName + ".dataCenter.name");
        int dcTries = Integer.parseInt(confProps.getProperty(Start.CORMORANT_SERVERS
                                                                       + '.'
                                                                       + serverPropName
                                                                       + ".dataCenter.tries",
                                                               "" + BulletproofVestFactory.getDefaultNumRetry()));
        pl = new PlottableImpl(cacheOnly,
                               dcDNS,
                               dcName,
                               dcTries,
                               dbConnCreator);
    }

    public Servant getServant() {
        return pl;
    }

    public void destroy() throws Exception {
        pl.shutdownDB();
        super.destroy();
    }

    private PlottableImpl pl = null;
}